hdu 2473 Junk-Mail Filter 并查集 删除点

来源:互联网 发布:sql中not in 没有效果 编辑:程序博客网 时间:2024/06/06 04:48
题意:
有n封邮件现在要将其含有相同的特征的放在一起,
M X Y代表X,Y具有相同的特征,S Y代表Y被错判了
现在问你这两种操作完成后还有多少种的信,注意
特征可以传递 X Y 有相同特征Y Z有相同的特征,则
X Y Z同时具有相同的特征。如果X Y Z中有一个被
误判这剩下的两个仍然具有相同的特征。

Description

Recognizing junk mails is a tough task. The method used here consists of two steps: 
1) Extract the common characteristics from the incoming email. 
2) Use a filter matching the set of common characteristics extracted to determine whether the email is a spam. 

We want to extract the set of common characteristics from the N sample junk emails available at the moment, and thus having a handy data-analyzing tool would be helpful. The tool should support the following kinds of operations: 

a) “M X Y”, meaning that we think that the characteristics of spam X and Y are the same. Note that the relationship defined here is transitive, so 
relationships (other than the one between X and Y) need to be created if they are not present at the moment. 

b) “S X”, meaning that we think spam X had been misidentified. Your tool should remove all relationships that spam X has when this command is received; after that, spam X will become an isolated node in the relationship graph. 

Initially no relationships exist between any pair of the junk emails, so the number of distinct characteristics at that time is N. 
Please help us keep track of any necessary information to solve our problem.
 

Input

There are multiple test cases in the input file. 
Each test case starts with two integers, N and M (1 ≤ N ≤ 10 5 , 1 ≤ M ≤ 10 6), the number of email samples and the number of operations. M lines follow, each line is one of the two formats described above. 
Two successive test cases are separated by a blank line. A case with N = 0 and M = 0 indicates the end of the input file, and should not be processed by your program.
 

Output

For each test case, please print a single integer, the number of distinct common characteristics, to the console. Follow the format as indicated in the sample below.
 

Sample Input

5 6M 0 1M 1 2M 1 3S 1M 1 2S 33 1M 1 20 0
 

Sample Output

Case #1: 3Case #2: 2
 

#include <iostream>#include <cstdio>#include <string>#include <cstring>#include <algorithm>using namespace std;int set[1000001],rank[1000001],v1[1000001];int find(int x){   if(set[x]!=x)   {       set[x]=find(set[x]);   }   return set[x];}void get(int x,int y){    int xx=find(x);    int yy=find(y);    if(xx!=yy)    {        set[xx]=yy;        rank[yy]+=rank[xx];        rank[xx]=0;    }}int main(){    int n,m;    char ch;    int u,v;    int Case=1;    while(~scanf("%d %d",&n,&m),n||m)    {        int num=n;        int s=0;        for(int i=0; i<n; i++)        {            set[i]=i;             v1[i]=i;            rank[i]=1;        }        while(m--)        {            getchar();            scanf("%c",&ch);            if(ch=='M')            {                scanf("%d %d",&u,&v);                get(v1[u],v1[v]);            }            else            {                scanf("%d",&u);                int xx=find(v1[u]);                rank[xx]--;                rank[num]=1;                v1[u]=num;                set[num]=num++;            }        }       for(int i=0; i<num; i++)            if(rank[i]>0)               s++;        printf("Case #%d: %d\n",Case++,s);    }    return 0;}

第一次接触并查集删除的题目看了别人的代码才懂得

因为并查集是树形结构,所以无法简单的把一个节点从一棵树中删去并维护原来的信息。那这里用到的思想就是还是保持原来的树的结构不变,只是把被删掉的那个点设为虚点,并新建一个点,把原来的点映射到这个新点上,代表以后的操作都是对这个新点进行操作。这样空间开销虽然大,但还是可以解决问题的。

#include<cstdio>#include<iostream>#include<algorithm>#include<cstring>using namespace std;int rank[20000],v[22000],set[20000];int find(int x){   int y=set[x];    if(set[x]!=x)    {        set[x]=find(set[x]);        rank[x]+=rank[y];    }    return set[x];}void get(int x,int y){    int xx=find(x);    int yy=find(y);    if(xx!=yy)    {        set[xx]=yy;        rank[yy]+=rank[yy];        rank[xx]=0;    }}int main(){    int n,m;    char ch;    int a,b;    int Case=1,s;    while(~scanf("%d %d",&n,&m),n||m)    {        int num=n;        s=0;        for(int i=0; i<=n; i++)        {            set[i]=i;            v[i]=i;            rank[i]=1;        }        while(m--)        {            getchar();            scanf("%c",&ch);            if(ch=='M')            {                scanf("%d %d",&a,&b);                get(v[a],v[b]);            }            else            {                scanf("%d",&a);                int xx=find(v[a]);                rank[v[a]]=0;                rank[xx]--;                rank[num]=1;                v[a]=num;                set[num]=num++;            }        }        for(int i=0; i<num; i++)            if(rank[i]>0)                s++;        printf("Case #%d: %d\n",Case++,s);    }}


0 0
原创粉丝点击